///////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2004 Intel Corporation 
// All rights reserved. 
//
// Redistribution and use in source and binary forms, with or without 
// modification, are permitted provided that the following conditions are met: 
//
// * Redistributions of source code must retain the above copyright notice, 
// this list of conditions and the following disclaimer. 
// * Redistributions in binary form must reproduce the above copyright notice, 
// this list of conditions and the following disclaimer in the documentation 
// and/or other materials provided with the distribution. 
// * Neither name of Intel Corporation nor the names of its contributors 
// may be used to endorse or promote products derived from this software 
// without specific prior written permission.
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
// A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL INTEL OR 
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY 
// OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
///////////////////////////////////////////////////////////////////////////

#if !defined _INCLUDED_PYRAMID_H
#define _INCLUDED_PYRAMID_H

#include "LocalBuffer.h"
#include "Image.h"

class PyrGauss
{
	private:
		LocalBuffer buf;

	public:
		PyrGauss();
		~PyrGauss();

		int PyrUp(Image8u* pSrc, Image8u* pDst);
		int PyrDown(Image8u* pSrc, Image8u* pDst);

		IppiSize GetDestSizeUp(Image8u* pSrc);
		IppiSize GetDestSizeDown(Image8u* pSrc);
};

class Pyramid8u
{
	public:
		enum { MaxLevels = 32 };

		Pyramid8u();
		~Pyramid8u();
		Image8u* GetLevel(int level);
		void SetTopLevel(Image8u* pImage);

	private:
		static PyrGauss pyr_;

		Image8u* pImages[MaxLevels];
		void FreeAll_();

};


#endif